//-----------------------------//
//Russell Vanek
//TCSS 342 HomeworkTHREE
//Objective: Alien Blurb Language
//January 24, 2006
// extensively modified by edhong. 2/2
// only main driver program remains the same. 
//
//-----------------------------//

import java.util.*;
import java.io.*;

public class blurbs 
{
	public static void main (String[] args)
	{
		
		Scanner sc = new Scanner (System.in);
		System.out.print("What is the file name you want to read? ");
		
		File f = new File(sc.nextLine());
		Scanner scanFile = null;
		try
		{
			scanFile = new Scanner (f);
		}
		catch (FileNotFoundException e)
		{
			System.out.println ("File not found " + e.getMessage());
			System.exit (1);
		}

		while (scanFile.hasNextLine())
        {
        	String linescan = scanFile.nextLine().toLowerCase().trim();
        	
        	if (IsBlurb(linescan))
    		{
    			System.out.println(linescan + " is a blurb");
    		}
    		else
    		{
    			System.out.println(linescan + " is not a blurb");
    		}
        }
	}
	
      //This method takes a string and finds out if it's a blurb
    // a blurb is a whoozit followed by one or more whatzits. 
	public static boolean IsBlurb (String s)
	{
		int endingIndex;
		// first look for this whoozit. 
                endingIndex = findWhoozit(s);
		if (endingIndex == -1)
		    return false; // unable to find a Whoozit at beginning of s
		else {
		    // loop to look for as many whatzits as can be found
		    int whatzitcount =0;
		    String restofs = s.substring(endingIndex+1);
		    while (endingIndex != -1) {
			endingIndex = findWhatzit(restofs);
			if (endingIndex != -1) {
			    restofs = restofs.substring(endingIndex+1);
			    whatzitcount++;
			}
		    } 
		    // no more whatzits, and whatzit count contains the number 
			// of whatzits found in s					
		    if (whatzitcount > 0 && restofs.length() == 0)
			   return true;		
		    else return false;		    
		}
	}
	
	//finds out if string s has a whoozit at its beginning. 
        //finds the maximum length string prefix of s that matches a whoozit. 
        // returns the index into the string of the end of the matching string
        // returns -1 if the prefix of s is not a whoozit. 
        // a whoozit is an 'x' followed by 0 or more 'y''s. 
	public static int findWhoozit (String s)
	{		
	    int counter;
		if (s.length() == 0) return -1;  // empty strings are not whoozits. 
		if (s.charAt(0) != 'x')
		    return -1;    // no whoozit found. 
		else {
		    counter = 1; 
		    // find as many y's as possible. 
		    while (counter < s.length() && s.charAt(counter) == 'y') {
			counter ++;
		    }
		    // at the end of this loop, counter is one beyond the last
		    // 'y' found (even if the string ends in 'y'). 
		    return counter -1; 
		}
	}
	
	
	//finds out if string s has a whatzit at its beginning. 
        //finds the maximum length string prefix of s that matches a whatzit. 
        // returns the index into the string of the end of the matching whatzit
        // returns -1 if the prefix of s is not a whoozit. 
        // a whatzit is a 'q', followed by a 'z' or 'd', followed by a whoozit.
	public static int findWhatzit (String s)
	{
	    if (s.length() < 2)  // no room for 'q' ('z' or 'd')
		return -1;
	    else {
		if ((s.charAt(0) == 'q')) {
			if (s.charAt(1) == 'd' || 
			    s.charAt(1) == 'z') {
			    // here we have a potential matching whatzit, 
			    // look for one ending whoozit. 
			    int index; 
			    index = findWhoozit(s.substring(2));
			    if (index == -1)  // no matching whoozit found
				return -1;
			    else return index+2; // add 2 to reflect the beginning 'q'('d' or 'z') 
			}
		}
		// one of the first two characters of s did not match
		return -1;
	    }

	}
}
